/*
     Destruccion del caza Hroki por Carlos Monterde Escudero

no suelo usar texturas predefinidas, me parece de gorrones, aunque no dudo
en "robarle" a Jose Manuel Muoz su modelo de caza Hroki, pero es por una
buena causa.

*/

//#include "colors.inc"
//#include "Golds.inc"
//#include "metals.inc"
//#include "skies.inc"
//#include "woods.inc"
//#include "textures.inc"


//#declare tex_metal1=texture{T_Silver_2E}
//#declare tex_metal2=texture{T_Silver_2C}
//#declare tex_cupula=texture{T_Gold_2C}
//#declare tex_reactor=texture{T_Silver_2E}

//intento de metal nuevo

#declare tex_metala1=texture{pigment{rgb<.6,.6,.6>}
                            finish{metallic on specular 1.5 roughness .1 brilliance 3 ambient .1}
                            }

//intento de metal oxidado

#declare tex_metalb1=texture{pigment{rgb<.6,.45,.3>}
                             finish{crand .1}
                             }

//la textura bozo que tanto me gusta para naves viejas

#declare tex_metal1 = texture{ bozo texture_map{[0 tex_metala1]
                                                [.4 tex_metala1]
                                                [1 tex_metalb1]
                                                }
                              scale 5}

//metal oscuro para los flaps de las alas

#declare tex_metal2=texture{pigment{rgb<.2,.2,.2>}
                            finish{metallic on specular .1}
                            }
//textura de la cabina

#declare tex_cupula=texture{pigment{rgb<.6,.4,.3>}
                            finish{ ambient .3 diffuse .7 metallic on specular 1.2 roughness .01 reflection .5 brilliance 3}}

//textura de los motores (bueno de uno, porque el otro... :-D :-D)

#declare tex_reactor=texture{pigment{rgb<.9,.9,.9>}
                             finish{metallic on specular .5 roughness .1 brilliance 2}
                             }

//textura del plasma del motor (no estoy seguro de que vaya a plasma.

#declare tex_plasma = texture{pigment{rgb<.7,.8,1.1>}
                              finish{ambient 1 diffuse 0}
                              }

/*
#declare tex_metal1=texture{pigment{Orange}}
#declare tex_metal2=texture{pigment{Orange}}
#declare tex_cupula=texture{pigment{Orange}}
#declare tex_reactor=texture{pigment{Orange}}  */


//pieza correspondiente a la vista superior del cuerpo central
#declare pi1top=prism{
cubic_spline
//linear_spline
    10,
    -10,
    36,
    <1,1>
    <2,-30>, <-2,-30>, <-5,-29>, <-7,-27>, <-9,-24>,
    <-10,-23>, <-12,-22>, <-13,-22>, <-15,-23>, <-17,-25>, <-19,-26>,
    <-20,-26>, <-22,-24>, <-23,-22>, <-24,-17>, <-24,-11>, <-23,-6>,
    <-22,-4>, <-21,2>, <-21,6>, <-22,14>, <-23,21>, <-22,26>, <-21,27>,
    <-19,28>, <-18,28>, <-16,27>, <-12,26>, <-11,26>, <-9,27>, <-5,29>,
    <-2,30>, <2,30>, <2,-30>,
    <-1,-1>
//no_shadow
}


//el perfil del cuerpo central de la nave visto desde arriba
#declare ptop=union{
         object{pi1top}
         object{pi1top rotate z*180}
         texture{tex_metal1}
}

//el cuerpo central de la misma
#declare ptopcentro=intersection{
        object{ptop}
        box{<-12,-10,-31>, <12,11,31>}
}

//la vista superior de los laterales de la nave
#declare ptoplateral=difference{
        object{ptop}
        box{<-12,-10,-31>, <12,11,31>}
}

//vista lateral del cuerpo central
#declare pilat=prism{
cubic_spline
    24,
    -24,
    31,
    <-4,-10>,
    <5,-30>, <4,-29>, <3,-26>, <1,-18>, <-1,-10>, <-2,-6>, <-4,-1>, <-6,2>,
    <-8,4>, <-9,5>, <-10,9>, <-10,11>, <-9,13>, <-7,16>, <-4,18>, <-2,21>,
    <-1,26>, <0,29>, <2,30>, <4,30>, <5,29>, <8,26>, <9,22>, <10,14>, <11,6>,
    <11,-10>, <10,-18>, <8,-29>, <5,-30>,
    <-4,10>
    texture{tex_metal1}
//no_shadow
scale<1,1,1.1>
}

// vista lateral de los extremos (toplat) de la nave
#declare pilat1=prism{
//    quadratic_spline
cubic_spline
    25,
    -25,
    33,
    <-4,-10>,
    <1,-26>, <0,-26>, <-1,-25>, <-2,-20>, <-3,-16>, <-5,-12>, <-6,-10>,
    <-6,-8>, <-4,-5>, <-2,-3>, <-1,1>, <-1,4>, <-3,10>, <-5,13>, <-6,16>,
    <-6,19>, <-4,23>, <-3,27>, <-2,28>, <2,28>, <3,27>, <5,22>, <6,18>,
    <6,12>, <5,5>, <5,-2>, <6,-6>, <6,-14>, <5,-20>, <3,-24>, <1,-26>,
    <4,10>
    texture{tex_metal1}
//no_shadow
scale<1,1,1.1>
}


#declare pifro1=prism{
    cubic_spline
    31,
    -31,
    26,
    <1,1>,
    <-3,-9>, <-6,-8>, <-8,-6>, <-11,-3>, <-13,-3>, <-16,-6>, <-19,-6>,
    <-22,-4>, <-24,-1>, <-24,0>, <-23,4>, <-21,6>, <-19,7>, <-16,7>,
    <-15,6>, <-13,3>, <-12,.75>, <-10,.75>, <-7,4>, <-4,8>, <-1,10>, <1,9.5>,
    <1,-8.5>, <-3,-9>,
    <-1,-1>
    texture{tex_metal1}
}

//pieza correspondiente a la vista frontal
#declare pifron=union{
    object{pifro1}
    object{pifro1 rotate z*180}
}

#declare pipropul=sor{
         9,
         <0,0>, <3,0>, <4,1>, <5,3>, <6,7>, <6,12>, <5,18>, <4,20>, <0,20>
}

//propulsores
#declare propul=union{
    difference{
         object{pipropul scale<1.2,1,1.2>}
         #declare cont=0
         #while (cont<330)
                box{<-1,10,-8>, <1,21,8> rotate y*cont}
         #declare cont=cont+30
         #end
         object{pipropul}
         }
    difference{
         object{pipropul}
         object{pipropul scale<.80,1.25,.80> translate <0,-1,0>}
         }
    texture{tex_reactor}
}

//plasma del motor, aadido por Carlos Monterde, para joder.
#declare plasma= intersection{ object{pipropul scale<.80,1.25,.80> translate<0,-1,0>}
                               box{<-10,10,-10><10,15,10>}
                               texture{tex_plasma}
                               }

//alas
#declare alah=difference{
    prism{
    linear_spline
        1,
        -1,
        7,
        <0,0>, <-60,0>, <-54,10>, <-24,18>, <-14,18>, <0,10>, <0,0>
    texture{tex_metal1}
    }
    union{
          box{<-20,0.5,6>, <-55,2,20> }
          box{<-30,-2,8>, <-55,-.5,20> }

          box{<-8,0.5,-2>, <-16,2,20> }
          box{<-7,-2,-2>, <-14,-.5,20> }
          texture{tex_metal2}
          }
}

//cabina
#declare cupula=intersection{
    prism{
        cubic_spline
        0,
        8,
        15,
        <1,1>,
        <-3,-10>, <-5,-7>, <-7,-1>, <-7,5>, <-5,8>, <-2,10>,
        <2,10>, <5,8>, <7,5>, <7,-1>, <5,-7>, <3,-10>, <-3,-10>,
        <1,1>
        }
    prism{
        cubic_spline
        9,
        -9,
        12,
        <1,1>,
        <4,-10>, <3,-10>, <-1,-6>, <-3,-2>, <-4,2>, <-4,6>, <-3,9>,
        <-1,10>, <4,10>, <4,-10>,
        <-1,-1>
        scale <1,1,1.1>
        rotate z*-90
        }
    texture{tex_cupula}
}

//el caza
#declare nave=union{
    intersection{
        union{
         intersection{
              object{ptopcentro}
              object{pilat rotate z*-90}
              }
         intersection{
            object{ptoplateral}
            object{pilat1 rotate z*-90}
            }
         }
        object{pifron rotate x*90}
    }
//ventana frontal
    object{cupula translate<0,3,-2>}
    object {propul rotate x*90 translate<26,0,4> }
    object {plasma rotate x*90 translate<26,0,4> }
    light_source{<26,0,24> rgb<.7,.7,1.2>fade_distance 10 fade_power 2}
    //light_source{<-26,0,24> rgb<.7,.7,1.2>fade_distance 10 fade_power 2}
   object{alah rotate z*35 translate <-28,0,10>}
     //object {plasma rotate x*90 translate<-26,0,4> }
    //object {propul rotate x*90 translate<-26,0,4> }
    sphere{<0,0,0> 20 pigment{rgbt<1,1,1,1>}
                        halo{emitting spherical_mapping linear color_map {[ 0 color rgbt <1, 0, 0, 1>][ 1 color rgbt <1, 1, 0, .7>]}
                             scale 15 samples 20 turbulence .2}
          translate<-26,0,14>
          hollow}
    light_source{<-26,0,14> rgb<1,.8,0> fade_distance 100 fade_power 1}
    difference{object{alah rotate z*180 rotate z*-25 translate <28,0,10>}
               object{pipropul rotate x*90 translate<26,0,4>}
               }
// las dos alitas verticales, una de ellas desplazada por la explosion
    object{alah rotate z*-90 scale <.70,.50,.75> rotate z*15 translate <-24,7,12>}
    object{alah rotate z*-90 scale <.70,.50,.75> translate <24,7,12>}

//medio propulsor sobre el capo
    object {propul scale <1.45,1,1>  scale <.50,.50,.50> rotate x*90 translate<0,0,-25> }

scale .1}






